from Globals import InitializeClass
from MultiCatalogAware.MultiCatalogPathAwareness import MultiCatalogAware
from AccessControl import ClassSecurityInfo
from ExtensionClass import Base

class Catalogavel(Base, MultiCatalogAware):
    """
    Define metodos para gerenciar a indexacao do
    objeto no Catalogo Principal e no
    Catalogo de Workflow do site
    """

    security = ClassSecurityInfo()

    security.declareProtected('Modificar propriedades','manage_catalogIndex')
    def manage_catalogIndex(self, REQUEST=None):
        """
        Adiciona o Catalogo Principal e o
        Catalogo Workflow na lista de catalogos
        onde o objeto se auto-reindexa e
        indexa o objeto
        """

        self.unindex_object()

        ctwf = self.getCatalogWorkFlow()
        ctprinc = self.getCatalogPrincipal()

        catalogs = self.getCatalogs()

        if ctwf is not None:
          if not ctwf in catalogs:
            catalogs.append(ctwf)

        if ctprinc is not None and self.Catalogar():
          if not ctprinc in catalogs:
            catalogs.append(ctprinc)

        self.manage_editCataloger(catalogs)

        self.index_object()

        if REQUEST is not None:
          return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                  manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

    security.declareProtected('Modificar propriedades','manage_catalogUnIndex')
    def manage_catalogUnIndex(self, in_ZMI=1, REQUEST=None):
        """
        Remove o objeto do Catalogo Principal e remove
        o Catalogo Principal da lista de catalogos
        onde ele se auto-reindexa quando modificado.
        """

        self.unindex_object()

        ctwf = self.getCatalogWorkFlow()
        ctprinc = self.getCatalogPrincipal()

        catalogs = self.getCatalogs()

        if ctprinc is not None and not self.Catalogar():
          if ctprinc in catalogs:
            catalogs.remove(ctprinc)

        if ctwf is not None:
          if not ctwf in catalogs:
            catalogs.append(ctwf)

        self.manage_editCataloger(catalogs)

        self.index_object()

        if REQUEST is not None:
          return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                  manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

InitializeClass(Catalogavel)