import Globals
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from OFS.PropertyManager import PropertyManager
from ExtensionClass import Base

class PropriedadesGerenciaveis(PropertyManager, Base):

    property_extensible_schema__ = 1

    security = ClassSecurityInfo()

    security.declareProtected('View management screens', 'gadgetCustomProperties')
    gadgetCustomProperties = Globals.DTMLFile("dtml/gadgetCustomProperties", globals())

    def filtered_propertyMap(self):
        result = []
        for i in self.propertyMap():
          if 'd' in i.get('mode', 'awd'):
            result.append(i)
        return result

    security.declareProtected('Modificar propriedades','manage_addProperty')
    def manage_addProperty(self, id, value, type, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do Objeto"
        if self.canEdit():
          PropriedadesGerenciaveis.inheritedAttribute('manage_addProperty')(self, id=id, value=value, type=type, REQUEST=None)

        if REQUEST is not None:
          return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                  manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

    security.declareProtected('Modificar propriedades','manage_delProperties')
    def manage_delProperties(self, ids, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do Objeto"
        if self.canEdit():
          PropriedadesGerenciaveis.inheritedAttribute('manage_delProperties')(self, ids, REQUEST=None)

        if REQUEST is not None:
          return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                  manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)

    security.declareProtected('Modificar propriedades','manage_changeProperties')
    def manage_changeProperties(self, REQUEST=None):
        "Modifica as Propriedades do Objeto"
        if self.canEdit():
          apply(PropriedadesGerenciaveis.inheritedAttribute('manage_changeProperties'), [self], REQUEST.form)

        if REQUEST is not None:
            return self.manage_PropertiesForm(REQUEST, management_view = 'Propriedades',
                    manage_tabs_message='<strong>%s</strong> foi editado.' % self.id)


InitializeClass(PropriedadesGerenciaveis)