import XConteudo, OFS, Globals, time, DateTime
from AccessControl import ClassSecurityInfo
from OFS.Folder import Folder
from OFS.Cache import Cacheable
from DateTime import DateTime

_marker = []

class XPagina ( XConteudo.XConteudo ):
    """Classe que define a XPagina."""

    meta_type = 'XPagina'
    friendly_name = 'Pgina'

    security = ClassSecurityInfo()

    security.declareProtected('Modificar propriedades', 'manage_PropertiesForm')
    manage_PropertiesForm = Globals.DTMLFile("dtml/editXPaginaForm", globals(), in_ZMI=1)

    def __init__(self, id, title):
        self.id = id
        self.title = title

    security.declareProtected('Modificar propriedades', 'manage_Properties')
    def manage_Properties(self, title, texto="", mostrar_no_menu_superior=0, mostrar_no_menu_esquerdo=0, mostrar_no_menu_direito=0,
    usar_structured_text=0, summary=None, keywords=None, document_format='DTML', in_ZMI=1, REQUEST=None, *args, **kw):
        "Modifica as Propriedades do XPagina"
        if self.canEdit():
          self.title = title
          self.mostrar_no_menu_superior = mostrar_no_menu_superior
          self.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
          self.mostrar_no_menu_direito = mostrar_no_menu_direito
          self._text = texto
          self._usar_structured_text = usar_structured_text
          self._summary = summary
          self._keywords = keywords
          self._document_format = document_format
          if self.getDocumentFormat() == 'ZPT' and hasattr(self, '_cook'):
            self._cook()
          self.manage_catalogIndex()

          self.ZCacheable_invalidate()
        if REQUEST is not None:
          return self.manage_PropertiesForm(REQUEST, management_view='Propriedades',
              manage_tabs_message='A Pagina <strong>%s</strong> foi editada.' % self.id
              )

Globals.default__class_init__(XPagina)

def manage_addXPagina(self, id, title, produtor=None,
        data_inicial=None, data_final=None, texto="", summary=None, keywords=None,
        mostrar_no_menu_superior=0, mostrar_no_menu_direito=0, mostrar_no_menu_esquerdo=0,
        usar_structured_text=0, categorias=None, novas_categorias=None, document_format='DTML', REQUEST=None):
        """Cria um XPagina e o adiciona ao seu parent Folder.
        O argumento 'self' referencia o parent Folder.
        """
        pagina = XPagina(id, title)
        if produtor is None:
          if REQUEST is None:
            pagina.produtor = 'admin'
          else:
            pagina.produtor = REQUEST.AUTHENTICATED_USER.getId()
        else:
          pagina.produtor = produtor
        if novas_categorias:
            if categorias is None:
              categorias = novas_categorias
            else:
              categorias.extend(novas_categorias)
        if categorias is None:
            categorias = []
        for i in range(0, categorias.count("")):
          try: categorias.remove("")
          except: pass
        pagina.categorias = categorias
        pagina._summary = summary
        pagina._keywords = keywords
        pagina._document_format = document_format
        pagina.manage_PeriodoExibicao(data_inicial = data_inicial, data_final = data_final)
        pagina.mostrar_no_menu_superior = mostrar_no_menu_superior
        pagina.mostrar_no_menu_esquerdo = mostrar_no_menu_esquerdo
        pagina.mostrar_no_menu_direito = mostrar_no_menu_direito
        pagina._data_criacao = DateTime()
        pagina._text = texto
        pagina._usar_structured_text = usar_structured_text
        self._setObject(id, pagina)
        pagina = self.restrictedTraverse(id)
        pagina.manage_workflow_statusProduzindo()
        if pagina.getDocumentFormat() =='ZPT' and hasattr(pagina, '_cook'):
          pagina._cook()
        pagina.manage_catalogIndex()

        if REQUEST is not None:
                return self.manage_main(self, REQUEST)

manage_addXPaginaForm = Globals.DTMLFile('dtml/addXPaginaForm', globals())
