from Products.Photo.PhotoFolder import PhotoFolder
from XSecao import XSecao
from Globals import InitializeClass, DTMLFile
from XPagina import XPagina

class XPhotoFolder(PhotoFolder, XSecao):
    """
    Wrapper para utilizar o PhotoFolder
    como uma XSecao.
    """

    meta_type = "XPhotoFolder"

    def __setstate__(self, state):
        XPhotoFolder.inheritedAttribute('__setstate__')(self, state)
        if not hasattr(self, '_historico'):
          self._historico = []

    def manage_options(self, REQUEST=None):
        
        options = ( PhotoFolder.manage_options[:1] + XSecao.manage_options(self)[1:4] + PhotoFolder.manage_options[1:])
        
        return options

manage_addPhotoFolderForm = DTMLFile('dtml/addPhotoFolderForm', globals())

def manage_addPhotoFolder(dispatcher, id, title, store='Image',
                          engine='ImageMagick', quality=75, pregen=0, timeout=0,
                          createsamples=0, REQUEST=None):
    """Add Photo Folder object"""
    dest = dispatcher.Destination()
    dest._setObject(id, XPhotoFolder(id, title, store, engine, quality, pregen, timeout))
    self = dest._getOb(id)
    self.mostrar_no_menu_esquerdo = 0
    self.mostrar_no_menu_direito = 0
    
    if createsamples:
        listar = """<h2> 
  <dtml-var name="title_or_id">
</h2>
<dtml-if description>
<p> 
  <dtml-var description newline_to_br>
</p>
</dtml-if>
<table width="80%" border="0" align="CENTER" cellspacing="0" cellpadding="5">
  <dtml-in expr="_.range(_.math.ceil(_.len(REQUEST.PARENTS[1].objectIds(['Photo'])) / 4.0))">
  <dtml-let start="_['sequence-item'] * 4 + 1">
  <tr> 
    <dtml-in expr="REQUEST.PARENTS[1].objectValues(['Photo'])" sort="id" size="4" orphan="0" start="start">
    <td align="CENTER"><a href="&dtml.url-sequence-item;/view"> 
      <dtml-var expr="tag(display='thumbnail', border=0, cookie=0)">
      <br>
      <dtml-var name="title_or_id">
      </a></td>
    </dtml-in>
  </tr>
  </dtml-let>
  </dtml-in>
</table>
"""        
        self.manage_addProduct['ZCoMIX'].manage_addXPagina(id='listar', title='Lista de Imagens', texto=listar, mostrar_no_menu_esquerdo=0)
        pagina = getattr(self, 'listar')
        pagina.manage_workflow_statusPublicado()
        self.pagina_inicial = 'listar'
        self.manage_workflow_statusProduzindo()
        self.manage_changeUsarPai(usar_menu_pai=1, esquerdo=1)
        self.manage_changeUsarPai(usar_menu_pai=1, esquerdo=0)
        self.manage_workflow_statusPublicado()
        
        view = """
<table border="0" cellpadding="0" cellspacing="0" width="75%" align="center">
  <tr> 
    <td align="left" width="25%" valign="top"> 
      <dtml-try>
      &lt;&nbsp; 
      <dtml-with prevPhoto only>
      <a href="&dtml-absolute_url;/view"><small> 
      <dtml-var title_or_id>
      </small></a> 
      </dtml-with>
      <dtml-except>
      &nbsp; 
      </dtml-try>
    </td>
    <td align="center" width="50%"> 
      <h3> 
        <dtml-var "REQUEST.PARENTS[1].title_or_id()">
      </h3>
    </td>
    <td align="right" width="25%" valign="top"> 
      <dtml-try>
      <dtml-with nextPhoto only>
      <a href="&dtml-absolute_url;/view"><small> 
      <dtml-var title_or_id>
      </small></a> 
      </dtml-with>
      &nbsp;&gt; 
      <dtml-except>
      &nbsp; 
      </dtml-try>
    </td>
  </tr>
  <tr> 
    <td colspan="3"> 
      <table border="0" cellspacing="0" cellpadding="0" width="50%" align="center">
        <tr> 
          <td align="center" colspan="<dtml-var "_.len(displayIds())">"> 
            <dtml-var "tag(display=REQUEST.get('display', 'small'), border=1, cookie=1)">
          </td>
        </tr>
        <tr> 
          <dtml-in displayLinks>
          <td align="center"><small>
            <dtml-var sequence-item>
            </small></td>
          </dtml-in>
        </tr>
        <tr> 
          <td align="center" colspan="<dtml-var "_.len(displayIds())">"> <small><a href="&dtml-absolute_url;?display=">Download
            full-size image</a></small></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr> 
    <td colspan="3">&nbsp;</td>
  </tr>
</table>
"""

        
        self.manage_addProduct['ZCoMIX'].manage_addXPagina(id='view', title='Visualizacao da Imagem', texto=view, mostrar_no_menu_esquerdo=0)
        pagina = getattr(self, 'view')
        pagina.manage_workflow_statusPublicado()

    if REQUEST is not None:
        try:    url=dispatcher.DestinationURL()
        except: url=REQUEST['URL1']
        REQUEST.RESPONSE.redirect('%s/manage_main' % url)
    return id

InitializeClass(XPhotoFolder)
