import Globals, Products
from XSecao import XSecao
from XSite import XSite
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from OFS.Folder import Folder

class XTemplate ( Folder ):
    """Classe que define o XTemplate."""

    security = ClassSecurityInfo()

    friendly_name = 'Template'
    meta_type = 'XTemplate'

    itensMenuDireito = XSecao.itensMenuDireito
    itensMenuEsquerdo = XSecao.itensMenuEsquerdo
    itensMenu = XSecao.itensMenu

    def all_meta_types(self):
        """ What can you put inside me? """
        f = lambda x: x['name'] not in ('XSecao','XPagina','XLink','XSite','XNoticia','XTemplate')
        return filter(f, Products.meta_types)

    _properties = (
        {'id':'title','type':'string','mode':'w'},
        )

    def manage_options(self, REQUEST=None):
        options=(Folder.manage_options)

        return options

    def __init__(self, id, title):
        self.id = id
        self.title = title

    def __bobo_traverse__(self, request, entry_name):
        """Faz um Mirror do Template Principal."""
        path= getattr(request,'TraversalRequestNameStack',None)
        found = 1
        mid = self.getTemplatePrincipal()
        mf = getattr(self, mid, None)
        if (entry_name != mid) and mf and (path is not None) and (self.getId()!=mid):
          path= path[:]
          path.append(entry_name)
          path.reverse()

          # try to find object on the current template
          context = self.__of__(mf)
          for s in path:
            try: ncontext = context.restrictedTraverse(s)
            except:
              found = 0
              break
            if not hasattr(ncontext,'__basicnew__'):break
            context = ncontext
          if found:
            return getattr(self.__of__(mf), entry_name)

          # if we couldnt find it on the current template, try the default template
          context= mf
          for s in path:
            try: ncontext= context.restrictedTraverse(s)
            except: break
            if not hasattr(ncontext,'__basicnew__'): break
            context = ncontext
          self = self.__of__(context)
        return getattr(self, entry_name)

InitializeClass(XTemplate)

def manage_addXTemplate(self, id, title, REQUEST=None):
    """Cria um XTemplate e o adiciona ao seu parent Folder.
    O argumento 'self' referencia o  parent Folder.
    """
    template = XTemplate(id, title)
    self._setObject(id, template)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

manage_addXTemplateForm = Globals.HTMLFile('dtml/addXTemplateForm', globals())
