import Globals, ExtensionClass, string, time, DateTime
from Globals import InitializeClass, Persistent
from AccessControl import ClassSecurityInfo
from AccessControl import SecurityManagement
from DocumentTemplate.DT_Var import url_quote_plus
from Products.ZCatalog.ZCatalog import ZCatalog
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

class XWorkFlowCatalog ( ZCatalog ):
    """Classe para gerenciamento do WorkFlow."""

    meta_type = 'XWorkFlowCatalog'

    security = ClassSecurityInfo()
    security.declareProtected('Gerenciar Workflow', 'manage_WorkFlowForm')
    manage_WorkFlowForm = PageTemplateFile("www/manageWorkFlow", globals(), in_ZMI=1)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','gadgetWorkFlowForm')
    gadgetWorkFlowForm = PageTemplateFile("www/manageWorkFlow", globals(), in_ZMI=0)

    security.declareProtected('Utilizar Interface de Gerenciamento do ZCoMIX','manage_ZWorkFlowForm')
    manage_ZWorkFlowForm = Globals.DTMLFile("dtml/ZTemplate", globals(), in_ZMI=0, z_conteudo='gadgetWorkFlowForm')

    def manage_options(self, REQUEST=None):
      manage_options = ((
          {'label':'Workflow', 'action':'manage_WorkFlowForm'},
          ) + ZCatalog.manage_options )

      zcomix_manage_options = ((
          {'label':'Workflow', 'action':'manage_ZWorkFlowForm'},
          ) + ZCatalog.manage_options )

      if self.SecurityGetUser().has_permission('View management screens', self):
        return manage_options
      else:
        return zcomix_manage_options

InitializeClass(XWorkFlowCatalog)

def manage_addXWorkFlowCatalog(self, id, title, REQUEST=None):
      """Catalogo para Gerenciamento do WorkFlow."""
      catalogo = XWorkFlowCatalog(id, title)
      self._setObject(id, catalogo)
      catalogo = getattr(self, id)
      catalogo.manage_addColumn(name='getStatus')
      catalogo.manage_addColumn(name='getWorkFlowStatus')
      catalogo.manage_addColumn(name='produtor')
      catalogo.manage_addColumn(name='publicador')
      catalogo.manage_addColumn(name='revisor')
      catalogo.manage_addColumn(name='title_or_id')
      catalogo.manage_addColumn(name='title_and_id')
      catalogo.manage_delColumn(names='summary')
      catalogo.manage_delIndex(ids='PrincipiaSearchSource')
      catalogo.manage_addIndex(name='getStatus', type='KeywordIndex')
      catalogo.manage_addIndex(name='getWorkFlowStatus', type='KeywordIndex')
      catalogo.manage_addIndex(name='produtor', type='KeywordIndex')
      catalogo.manage_addIndex(name='publicador', type='KeywordIndex')
      catalogo.manage_addIndex(name='revisor', type='KeywordIndex')
      path = string.join(self.getPhysicalPath(), '/')
      obj = self.restrictedTraverse(path)
      catalogo.ZopeFindAndApply(obj, obj_metatypes=['XSecao', 'XPagina', 'XLink', 'XNoticia'], search_sub=1,
      apply_func=catalogo.catalog_object, apply_path=path)
      if REQUEST is not None:
        return self.manage_main(self, REQUEST)

manage_addXWorkFlowCatalogForm = Globals.DTMLFile("dtml/addXWorkFlowCatalogForm", globals(), in_ZMI=1)
