from OFS.content_types import guess_content_type
from OFS.Image import Image, File
from string import letters
import re, sys
from DateTime import DateTime

def fileUpload(self, id='', file=None):
    """
    Upload a file.
    
    Try to guess id and content type.
    """
    
    REQUEST = self.REQUEST
    
    body=REQUEST.get('BODY', '')
    typ=REQUEST.get_header('content-type', None)
    
    if file and file.filename:
        if not id:
            id = file.filename
        if not body:
            body = file.read()
        content_type = file.headers['Content-Type']
        if guess_content_type(id, body)[0][0:5] == 'image':
            ob=Image(id, '', body, content_type=content_type)            
        else:
            ob=File(id, '', body, content_type=content_type)
        self._setObject(id, ob)
        ob = getattr(self, id)
        return ob
    return

def makeEmailLinks(str):
    """
    Build html links from emails.
    """
    
    if not str: return
    mail_expr=re.compile(r'(^|\s)([_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*(\.[a-zA-Z]{2,4}))', re.MULTILINE)
    str = mail_expr.sub(r'\1<a href="mailto:\2">\2</a>', str)
    return str

def dt2us(data):
    """
    Turn a string containing a date in pt_BR format
    into a date in US format.
    """

    if data is None:
        data = DateTime().strftime('%d/%m/%Y %H:%M:%S')
    data_us = data[6:10]+'-'+data[3:5]+'-'+data[:2]+data[10:]
    return data_us
